package com.qmth.eds.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.eds.bean.dto.AssignListDto;
import com.qmth.eds.bean.dto.ExamAssignDto;
import com.qmth.eds.common.entity.*;
import com.qmth.eds.common.util.ServletUtil;
import com.qmth.eds.mapper.ExamAssignMapper;
import com.qmth.eds.service.ExamAssignService;
import com.qmth.eds.service.ExamSyncStudentService;
import com.qmth.eds.service.ExamSyncTotalService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Map;

/**
 * <p>
 * 赋分管理 服务实现类
 * </p>
 */
@Service
public class ExamAssignServiceImpl extends ServiceImpl<ExamAssignMapper, ExamAssign> implements ExamAssignService {

    @Resource
    ExamSyncTotalService examSyncTotalService;

    @Resource
    ExamSyncStudentService examSyncStudentService;

    @Override
    public IPage<AssignListDto> pageData(Long semesterId, Long examTypeId, String courseCode, Integer pageNumber, Integer pageSize) {
        SysUser sysUser = (SysUser) ServletUtil.getRequestUser();
        Page<AssignListDto> page = new Page<>(pageNumber, pageSize);
        IPage<AssignListDto> assignListDtoIPage = this.baseMapper.pageData(page, sysUser.getOrgId(), semesterId, examTypeId, courseCode);

        ExamSyncTotal examSyncTotal = examSyncTotalService.getBySemesterIdAndExamTypeIdAndDownloadStatus(semesterId, examTypeId, true);

        for (AssignListDto record : assignListDtoIPage.getRecords()) {

        }

        return assignListDtoIPage;
    }

    @Override
    public boolean calcData(Long semesterId, Long examTypeId, String courseCode, String courseName, String formula, Double fullScore, Double passScore, String coefficient) {
        // 保存赋分参数

        // 计算赋分
        return true;
    }

    @Override
    public IPage<CloudMarkingScore> result(Long semesterId, Long examTypeId, String courseCode, String courseName, String formula, Integer pageNumber, Integer pageSize) {
        return null;
    }

    @Override
    public Map contrast(Long semesterId, Long examTypeId, String courseCode) {
        return null;
    }

    @Override
    public ExamAssignDto toCalc(Long semesterId, Long examTypeId, String courseCode) {
        return null;
    }
}
