package com.qmth.eds.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qmth.eds.bean.dto.AssignListDto;
import com.qmth.eds.common.entity.ExamAssign;
import org.apache.ibatis.annotations.Param;

/**
 * <p>
 * 赋分管理 Mapper 接口
 * </p>
 */
public interface ExamAssignMapper extends BaseMapper<ExamAssign> {

    IPage<AssignListDto> pageData(@Param("page") Page<AssignListDto> page, @Param("schoolId") Long schoolId, @Param("semesterId") Long semesterId, @Param("examTypeId") Long examTypeId, @Param("courseCode") String courseCode);
}
