package com.qmth.eds.service.impl;

import com.qmth.eds.common.entity.SysRole;
import com.qmth.eds.mapper.SysRoleMapper;
import com.qmth.eds.service.SysRoleService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 角色表 服务实现类
 * </p>
 *
 * @author wangliang
 * @since 2022-05-14
 */
@Service
public class SysRoleServiceImpl extends ServiceImpl<SysRoleMapper, SysRole> implements SysRoleService {

    @Override
    public List<SysRole> listByUserId(Long userId) {
        return this.baseMapper.listByUserId(userId);
    }
}
